/*
 Autor: Jose Alberto Gandullo Ávila
 Proyecto: SIMOCAP
 Blog: http://simocap.wordpress.com
 correo: yoalberto007@gmail.com
 fecha: 2010-06-08
 */

#include <stdio.h>
#include <stdlib.h>

int copyFile() {
	FILE *input, *output;
	char leido;
	char copia[255] = "base.bvh";
	int i;

	printf("Preparando archivo bvh auxiliar\n");
	//printf("Ejemplo : 'entrada.txt' (sin las comillas)\n");


	if ((input = fopen(copia, "r")) == NULL) {
		printf("\n El Archivo de entrada no existe \n");

		return 1;
	}

	output = fopen("aux.bvh", "w");

	while (!feof(input)) {
		leido = fgetc(input);
		if (!feof(input))
			fputc(leido, output);

	}

	printf("Archivo bvh auxiliar listo \n");
	fclose(input);
	fclose(output);

	return 0;
}

int promedio(double in[], double out[], int lineas) {
	int i;
	out[0] = in[0];
	out[1] = in[1];
	out[2] = in[2];
	for (i = 3; i < lineas - 3; i++) {
		out[i] = in[i - 3] * 0.05 + in[i - 2] * 0.1 + in[i - 1] * 0.2 + in[i]
				* 0.3 + in[i + 1] * 0.2 + in[i + 2] * 0.1 + in[i + 3] * 0.05;
	}
	out[lineas - 2] = in[lineas - 2];
	out[lineas - 1] = in[lineas - 1];
	out[lineas] = in[lineas];
}

int postprocesado() {

	FILE *f;
	long contador_lineas, lineas;
	double cX[1024], cY[1024], cZ[1024];
	double rX[1024], rY[1024], rZ[1024];
	double bX[1024], bY[1024], bZ[1024];
	double rbX[1024], rbY[1024], rbZ[1024];
	double a, b, c, d, e, g;
	char cadena[600];
	FILE *input, *output;
	char leido, copia[255], copia2[255];
	char file[255] = "aux.bvh";
	int outscan;
	char out[255];
	//altura a la que se coloca el modelo
	double altura = 43.52;
	printf("POSTPROCESADO \n");
	printf(
			"Escriba como quiere nombrar al archivo de salida.\n ");
	printf("Ejemplo : 'salida.bvh' (sin las comillas)\n");
	
	getchar(); //arreglo para que funcione el scanf siguiente
	outscan = scanf("%[^\n]s", out);

	int i;

	f = fopen(file, "r");
	contador_lineas = 1;
	lineas = 0;
	i = 0;

	while (fgets(cadena, 600, f) != NULL) {

		//printf("%s",cadena);
		// se salta las primeras 120 que no corresponden a frames 
		//(las que configuran la estructura)
		if ((sscanf(
				cadena,
				"0.00 43.52 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 %lf %lf %lf 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 %lf %lf %lf 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 \n",
				&a, &b, &c, &d, &e, &g) > 0) && (contador_lineas > 120)) {

			//valores para cabeza
			cX[i] = a;
			cZ[i] = b;
			cY[i] = c;
			//valores para brazo
			bX[i] = d;
			bZ[i] = e;
			bY[i] = g;

			printf("Recupero %3.2lf  %3.2lf %3.2lf %3.2lf  %3.2lf %3.2lf\n",
					cX[i], cY[i], cZ[i], bX[i], bY[i], bZ[i]);
			i++;
			lineas++;
		}
		contador_lineas++;

	}
	fclose(f);

	promedio(cX, rX, lineas);
	promedio(cY, rY, lineas);
	promedio(cZ, rZ, lineas);

	promedio(bX, rbX, lineas);
	promedio(bY, rbY, lineas);
	promedio(bZ, rbZ, lineas);

	/*for (i = 3; i < lineas - 3; i++) {
	 printf("%3.2lf  %3.2lf %3.2lf ## ", bX[i], bY[i], bZ[i]);

	 rX[i] = cX[i - 3] * 0.05 + cX[i - 2] * 0.1 + cX[i - 1] * 0.2 + cX[i]
	 * 0.3 + cX[i + 1] * 0.2 + cX[i + 2] * 0.1 + cX[i + 3] * 0.05;
	 rY[i] = cY[i - 3] * 0.05 + cY[i - 2] * 0.1 + cY[i - 1] * 0.2 + cY[i]
	 * 0.3 + cY[i + 1] * 0.2 + cY[i + 2] * 0.1 + cY[i + 3] * 0.05;
	 rZ[i] = cZ[i - 3] * 0.05 + cZ[i - 2] * 0.1 + cZ[i - 1] * 0.2 + cZ[i]
	 * 0.3 + cZ[i + 1] * 0.2 + cZ[i + 2] * 0.1 + cZ[i + 3] * 0.05;
	 
	 rbX[i] = bX[i - 3] * 0.05 + bX[i - 2] * 0.1 + bX[i - 1] * 0.2 + bX[i]
	 * 0.3 + bX[i + 1] * 0.2 + bX[i + 2] * 0.1 + bX[i + 3] * 0.05;
	 rbY[i] = bY[i - 3] * 0.05 + bY[i - 2] * 0.1 + bY[i - 1] * 0.2 + bY[i]
	 * 0.3 + bY[i + 1] * 0.2 + bY[i + 2] * 0.1 + bY[i + 3] * 0.05;
	 rbZ[i] = bZ[i - 3] * 0.05 + bZ[i - 2] * 0.1 + bZ[i - 1] * 0.2 + bZ[i]
	 * 0.3 + bZ[i + 1] * 0.2 + bZ[i + 2] * 0.1 + bZ[i + 3] * 0.05;

	 printf("%3.2lf  %3.2lf %3.2lf \n ", rbX[i], rbY[i], rbZ[i]);
	 }*/
	printf("numero lineas: %ld \n ", lineas);

	if ((input = fopen("base.bvh", "r")) == NULL) {
		printf("\n El Archivo de entrada no existe \n");
		return 1;
	}

	output = fopen("aux2.bvh", "w");

	while (!feof(input)) {
		leido = fgetc(input);

		if (!feof(input)) {
			if (leido == '@') {
				fprintf(output, "%ld", lineas);
			} else {
				fputc(leido, output);
			}
		}
	}
	printf(
			"El archivo 'base.bvh' ha sido copiado a %s se inserta el numero de frames \n",
			file);
	fclose(input);
	fclose(output);

	f = fopen("aux2.bvh", "a");
	if (f == NULL) {
		fprintf(stderr, "No se pudo acceder al fichero");
	} else {
		for (i = 0; i < lineas - 3; i++) {

			fprintf(
					f,
					"0.00 %3.2lf 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 %3.2lf %3.2lf %3.2lf 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 %3.2lf %3.2lf %3.2lf 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00 \n",
					altura, rX[i], rZ[i], rY[i], rbX[i], rbZ[i], rbY[i]);

		}
	}
	fclose(f);

	// Copia archivo a salida cambiando comas por puntos

	if ((input = fopen("aux2.bvh", "r")) == NULL) {
		printf("\n El Archivo de entrada no existe \n");

		return 1;
	}

	output = fopen(out, "w");

	while (!feof(input)) {
		leido = fgetc(input);

		if (!feof(input)) {
			if (leido == ',') {
				//en algun compilador podria ser necesario 
				//cambiar las comas decimales por puntos
				fputc('.', output);
			} else {
				fputc(leido, output);
			}
		}
	}
	printf("El archivo de salida es %s \n", out);
	fclose(input);
	fclose(output);

	return 0;
}

